SystemOrganization addCategory: #ConfigurationOftODE!

Object subclass: #ConfigurationOftODE
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOftODE'!

!ConfigurationOftODE class methodsFor: 'development support' stamp: 'dkh 5/22/2011 12:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOftODE class methodsFor: 'metacello tool support' stamp: 'dkh 5/22/2011 12:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOftODE class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 12:40'!
project

	^self new project! !

!ConfigurationOftODE class methodsFor: 'development support' stamp: 'dkh 5/22/2011 12:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOftODE methodsFor: 'baselines' stamp: 'dkh 5/29/2011 14:06'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://seaside.gemstone.com/ss/Naviode'.
		spec project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					loads: #('Base' 'JQuery-UI');
					repository: 'http://www.squeaksource.com/Seaside30' ].
		spec project: 'JQueryWidgetBox' with: [
				spec
					className: 'ConfigurationOfJQueryWidgetBox';
					versionString: #'bleedingEdge';
					loads: #('JQWidgetBox-UILayout-Core');
					repository: 'http://www.squeaksource.com/JQueryWidgetBox' ].
		spec 
			package: 'tODE-Core';
			package: 'tODE-Seaside' with: [
				spec requires: #('tODE-Core' 'Seaside30' 'JQueryWidgetBox') ];
			package: 'tODE-Views' with: [
				spec requires: #('tODE-Core') ];
			package: 'tODE-Tests-Core' with: [
				spec requires: #('tODE-Core') ].
		spec group: 'default' with: #('tODE-Core' 'tODE-Seaside' 'tODE-Views' 'tODE-Tests-Core'). ].

	spec for: #'pharo' do: [
		spec 
			package: 'tODE-Views' with: [
				spec includes: 'tODE-Pharo-Views'];
			package: 'tODE-Pharo-Views' with: [
				spec includes: 'tODE-Views']. ].

	spec for: #'gemstone' do: [
		spec 
			package: 'tODE-Views' with: [
				spec includes: 'tODE-GemStone-Views'];
			package: 'tODE-GemStone-Views' with: [
				spec includes: 'tODE-Views']. ].
! !

!ConfigurationOftODE methodsFor: 'symbolic versions' stamp: 'dkh 5/22/2011 12:40'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOftODE methodsFor: 'accessing' stamp: 'dkh 5/22/2011 12:40'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOftODE methodsFor: 'versions' stamp: 'dkh 5/30/2011 14:02'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '- checkpoint ... fleshing out the inspector
- KISSing
- get selected center tab indx logic straightened out
- add frame link to basic inspector view for an object
- inverse frame lookup to reuse frame state and object state
- eliminate frameIndex
0.1 (dkh.7):
- rearrange inspector pane
0.1 (dkh.8):
- getting started on tODE class browser
- tweak inspector
0.1 (dkh.9):
- tweaks
0.1 (dkh.10):
- TOTabSpec keeps the receiver and frame state itself
- added frame tab for inspecting the tODE subsystem
- added explorer view for class tab ... 
0.1 (dkh.11):
- in class explorer, clicking on class should browse refs, like the instance variables ...
0.1 (dkh.12):
- get started on method browser
0.1 (dkh.13):
- change the default application path...
0.1 (dkh.14):
- basic method viewing is implemented ...
0.1 (dkh.15):
- superclass navigation and method browser
0.1 (dkh.16):
- use accordion for method categories in sidebar
0.1 (dkh.17):
- class hierarchy sidebar
0.1 (dkh.18):
- first cut at sanitization in prep for GemStone port
0.1 (dkh.19):
- starting GemStone port
0.1 (dlh.20):
- continued gemstone port
- start adding workspace
0.1 (dkh.21):
- basic port to GemStone complete
0.1 (dkh.24):
- getting TOWorkspace view working ... todo: doit/inspecit
0.1 (dkh.25):
- worksapce is basically working now (safari and chrome)
0.1 (dkh.26):
- use buttons for certain links...
0.1 (dkh.27):
- navigation buttons
0.1 (dkh.28):
- straighten out the inspector ...
0.1 (dkh.29):
- add doit button to workspace 
- push:selecting: propogation
0.1 (dkh.30):
- send message button 
- bookmark button
- extra content ... select: function on collections
0.1 (dkh.31):
- getting started on error hanlding for expression evaluation
0.1 (dkh.32):
- progress on debugger
0.1 (dkh.33):
- debugger/inspector is coming together
0.1 (dkh.34):
- seaside error handlers call TODebugger
0.1 (dkh.35):
- big refactoring ... specifiy the rendererClass (view class) in the tabSpec and make it possible to access renderer independent of rendering ... to set state for example prior to rendering,,,
0.1 (dkh.36):
- tweak
0.1 (dkh.37):
- bookmarks implemented ... first cut
0.1 (dkh.38):
- start work on test case tab 
0.1 (dkh.38):
- hook up debugger to test runner
- fix test
0.1 (dhk.40):
- misc stuff
- start on search page
0.1 (dkh.41):
- search basics complete
- bare minimum for debugging errors during rendering phase
0.1 (dkh.42):
- save/cancel for mthod editor'.
		spec author: 'dkh'.
		spec timestamp: '5/30/2011 14:02'.
		spec 
			project: 'Seaside30' with: '3.0.5';
			project: 'JQueryWidgetBox' with: '1.9'.
		spec 
			package: 'tODE-Core' with: 'tODE-Core-dkh.25';
			package: 'tODE-Seaside' with: 'tODE-Seaside-dkh.16';
			package: 'tODE-Views' with: 'tODE-Views-dkh.32';
			package: 'tODE-Tests-Core' with: 'tODE-Tests-Core-dkh.3'. ].

	spec for: #'pharo' do: [
		spec package: 'tODE-Pharo-Views' with: 'tODE-Pharo-Views-dkh.15'. ].

	spec for: #'gemstone' do: [
		spec package: 'tODE-GemStone-Views' with: 'tODE-GemStone-Views-dkh.3'. ].
! !
